<template>
  <div class="flex px-4 pb-20" :class="show ? 'fadeInLeft' : 'hidden'">
    <div class="order-last w-5/6">
      <div class="px-3 py-8 bg-black bg-opacity-50 rounded-tr-xl rounded-br-xl">
        <h2 class="mb-10 text-[7vw] text-center text-white font-bold">
          {{ $t("joinnow") }}
        </h2>
        <el-form
          ref="formRef"
          :show-message="true"
          label-position="top"
          :model="formModel"
          :rules="formRules"
          :validate-on-rule-change="false"
          class="w-full mx-auto"
        >
          <div class="flex flex-col gap-[5vw]">
            <el-form-item
              :class="{ required: rules.Username.required }"
              prop="Username"
            >
              <el-input
                v-model="formModel.Username"
                :placeholder="$t('username')"
                type="text"
                @focus="focusState.Username = true"
                @blur="focusState.Username = false"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span>*</span>
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/user.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <info-on-focus :show="focusState.Username">
              <span>
                {{
                  $t(
                    "must_be_in_6-20_characters_use_only_letters_(a-z)_and_numbers_(0-9)_username_is_not_case_sensitive"
                  )
                }}
                {{ $t("can_not_include_illegal_characters") }}
              </span>
            </info-on-focus>
            <el-form-item
              :class="{ required: rules.Password.required }"
              prop="Password"
            >
              <el-input
                v-model="formModel.Password"
                :placeholder="$t('password')"
                type="password"
                @focus="focusState.Password = true"
                @blur="focusState.Password = false"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span>*</span>
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/padlock.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <info-on-focus :show="focusState.Password">
              <span>
                {{
                  $t(
                    "must be_in_6-20_characters_use_both_letters_(a-z)_and_numbers_(0-9)_password_is_case_sensitive"
                  )
                }}
                {{ $t("can_not_include_illegal_characters") }}
              </span>
            </info-on-focus>
            <el-form-item
              :class="{ required: rules.ConfirmPassword.required }"
              prop="ConfirmPassword"
            >
              <el-input
                v-model="formModel.ConfirmPassword"
                :placeholder="$t('confirm_password')"
                type="password"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span>*</span>
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/padlock.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <el-form-item
              :class="{ required: rules.Currency.required }"
              prop="Currency"
            >
              <el-select
                v-model="formModel.Currency"
                class="currency"
                :placeholder="$t('please_select_currency')"
                popper-class="bg-dropdown-customize"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span>*</span>
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/dollar.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
                <el-option
                  v-for="currency in currencies"
                  :key="currency"
                  :value="currency.Currency"
                  >{{ currency.Currency }}</el-option
                >
              </el-select>
            </el-form-item>
            <template v-for="property in availableProperties" :key="property.PropertyName">
            <div class="api-input-field">
            <theme-common-otp-field
              v-if="property.PropertyName === 'Phone'"
              v-model="formModel"
              :label="property.PropertyNameForDisplay"
              :phone-property="property.PropertyName"
              :is-required="rules[property.PropertyName].required"
              :loading="isGettingOtpCode"
              :next-request-in-seconds="nextRequestOtpInSeconds"
              @get-code="onGetVerificationCode"
            >
              <template #phone>
                <el-form-item 
                  :prop="property.PropertyName"
                  :class="{ required: rules[property.PropertyName].required }"
                >
                  <el-input
                    v-model="formModel[property.PropertyName]"
                    :placeholder="property.PropertyNameForDisplay"
                    @focus="focusState.Phone = true"
                    @blur="focusState.Phone = false"
                    :formatter="(value: string) => value" 
                    :parser="(value: string) => value.replace(/\D+/g, '')"
                  >
                    <template #prefix>
                      <div class="flex items-center">
                        <span v-show="property.PropertyStatus === 'Required'"
                          >*</span
                        >
                        <img
                          class="h-[6vw]"
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/mobile/images/phone.png'
                              )
                          "
                          alt=""
                          />
                      </div>
                    </template>
                  </el-input>
                  <info-on-focus :show="focusState.Phone">
                    <span>
                      {{
                        $t(
                          "valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes"
                        )
                      }}
                    </span>
                  </info-on-focus>
                </el-form-item>
              </template>
            </theme-common-otp-field>
            <el-form-item
              v-else
              :prop="property.PropertyName"
              :class="{ required: rules[property.PropertyName].required }"
            >
              <el-select
                v-if="property.PropertyName === 'Bank'"
                v-model="formModel.Bank"
                class="currency"
                popper-class="bg-dropdown-customize"
                :placeholder="$t('select_bank')"
                :disabled="bankOptions.length <= 0"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/bank.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
                <el-option
                  v-for="bank in bankOptions"
                  :key="bank.Id"
                  :label="bank.BankName"
                  :value="String(bank.Id)"
                />
              </el-select>
              <el-radio-group
                v-else-if="property.PropertyName === 'Gender'"
                v-model="formModel.Gender"
              >
                <el-radio label="male">{{ $t("male") }}</el-radio>
                <el-radio label="female">{{ $t("female") }}</el-radio>
              </el-radio-group>
              <template v-else-if="property.PropertyName === 'Email'">
                <el-input
                  v-model="formModel[property.PropertyName]"
                  :placeholder="property.PropertyNameForDisplay"
                  @focus="focusState.Email = true"
                  @blur="focusState.Email = false"
                  >
                  <template #prefix>
                    <div class="flex items-center">
                      <span v-show="property.PropertyStatus === 'Required'"
                        >*</span
                      >
                      <img
                        class="h-[6vw]"
                        :src="
                          getAssetImage(
                            'assets/theme/light_flexible_1/mobile/images/arroba.png'
                          )
                        "
                        alt=""
                      />
                    </div>
                  </template>
                </el-input>
                <info-on-focus :show="focusState.Email">
                  <span>
                    {{
                      $t(
                        "this_email_will_be_used_to_verify_your_identity, for_payment_registration, withdrawal_and_contact_purposes"
                      )
                    }}
                  </span>
                </info-on-focus>
              </template>
              <el-input
                v-else-if="property.PropertyName === 'FirstName'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/verify.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'LastName'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/verify.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'FullName'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/verify.png'
                        )
                      "
                      alt=""
                      />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'Mobile'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
                :formatter="(value: string) => value"
                :parser="(value: string) => value.replace(/\D+/g, '')"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/phone-app.png'
                        )
                      "
                      alt=""
                      />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'Line'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                      >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/line-app.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'BankAccountName'"
                v-model="formModel[property.PropertyName]"
                :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                :placeholder="property.PropertyNameForDisplay"
              >
                >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/account_name.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-date-picker
                v-else-if="property.PropertyName === 'DateOfBirth'"
                v-model="formModel[property.PropertyName]"
                :prefix-icon="Calendar"
                :placeholder="property.PropertyNameForDisplay"
                type="date"
                value-format="YYYY-MM-DD"
              />
              <el-input
                v-else-if="property.PropertyName === 'BankAccountNumber'"
                v-model="formModel[property.PropertyName]"
                :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                :placeholder="property.PropertyNameForDisplay"
                :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
              >
                >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/account_number.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'Referral'"
                v-model="formModel[property.PropertyName]"
                :disabled="referralQuery.length"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/users.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'PersonalSecurityCode'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/security.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else-if="property.PropertyName === 'Nationality'"
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <span v-show="property.PropertyStatus === 'Required'"
                      >*</span
                    >
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/united-nations.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
              <el-input
                v-else
                v-model="formModel[property.PropertyName]"
                :placeholder="property.PropertyNameForDisplay"
              />
            </el-form-item>
              </div>
            </template>
            <el-form-item v-if="cashAgentQuery.length">
              <el-input
                v-model="formModel.AgentName"
                :disabled="cashAgentQuery.length"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <img
                      class="h-[7vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/users.png'
                        )
                      "
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <div class="btn-click-captcha-to-verify">
              <el-form-item
                v-if="!registerCaptcha.IsHidden"
                prop="Captcha"
                :show-message="true"
                :class="{ required: rules.Captcha.required }"
              >
                <div id="captcha-button">
                  <div id="captcha-pop-up-verify" class="w-full">
                    <template
                      v-if="
                        !captchaErrorMsg.length &&
                        formModel.Captcha.length == 5 &&
                        !isDialogVisible
                      "
                    >
                      <div class="relative w-[18px] h-[18px]">
                        <img
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                            )
                          "
                          alt="verify icon success"
                          loading="lazy"
                        />
                      </div>
                      <span class="whitespace-nowrap">{{
                        $t("successful_verification")
                      }}</span>
                    </template>
                    <template v-else>
                      <div
                        class="flex items-center justify-center w-full gap-1"
                        @click="isDialogVisible = true"
                      >
                        <div class="relative w-[18px] h-[18px]">
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                              )
                            "
                            alt="verify icon"
                            loading="lazy"
                          />
                        </div>
                        <span>{{ $t("click_to_verify") }}</span>
                      </div>
                    </template>
                  </div>
                </div>
              </el-form-item>
            </div>
            <div v-if="isShowTerm" class="flex gap-1 px-6 text-white">
              <div class="text-[3.8] font-medium">
                {{ $t("when_you_click_register_mean_you_agree_with_the") }}
                <span
                  class="text-blue-500 display-term-and-condition"
                  @click="toggleTerms"
                >
                  {{ $t("term_and_condition") }}
                </span>
              </div>
            </div>
            <el-button
              class="h-[13.5vw] bg-gradient-to-r from-sky-500 to-indigo-500 rounded-full"
              style="border-radius: 9999px"
              :disabled="isLoading"
              @click="onRegister(formRef)"
            >
              <span
                class="text-2xl font-light text-center text-white bg-opacity-25"
                >{{ $t("submit") }}</span
              >
            </el-button>
          </div>
        </el-form>
      </div>
    </div>
    <div class="w-1/6" @click="toggleRegister">
      <div
        class="grid h-full gap-10 text-white bg-white bg-opacity-25 rounded-tl-xl rounded-bl-xl place-content-center"
      >
        <div class="flex flex-col items-center gap-4 py-10">
          <img
            class="max-w-[8vw] h-auto"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/login.png'
              )
            "
            alt="img"
          />
          <div
            class="flex flex-col jutify-center items-center text-xl font-bold text-[5vw]"
            style="writing-mode: vertical-rl"
          >
            {{ $t("capital_login") }}
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      v-model="isDialogVisible"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      width="320px"
      @open="formModel.Captcha = ''"
      @close="formRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!registerCaptcha.IsHidden"
        v-model:captcha="formModel.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive, ref } from "vue";
import { Search } from "@element-plus/icons-vue";
import Calendar from "../Calendar.client.vue";
import InfoOnFocus from "./InfoOnFocus.client.vue";
import useRegister from "@/composables/useRegister";
import { registerCaptcha } from "@/composables/captcha/useCaptcha";

export default defineComponent({
  name: "RegisterComponent",
  components: {
    InfoOnFocus,
  },
  props: {
    show: {
      type: Boolean,
      required: true,
    },
    isShowTerm: {
      type: Boolean,
      required: true,
    },
  },
  emits: ["toggleRegister", "toggleTerms"],
  setup(_, { emit }) {
    const {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const { getAssetImage } = commonHelper;
    const isDialogVisible = ref(false);
    const focusState = reactive({
      Username: false,
      Password: false,
      Email: false,
      Phone: false,
    });
    const toggleRegister = () => {
      emit("toggleRegister");
    };
    const toggleTerms = () => {
      emit("toggleTerms");
    };

    return {
      focusState,
      toggleRegister,
      toggleTerms,
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      Search,
      isDialogVisible,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      registerCaptcha,
      getAssetImage,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      Calendar,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>
<style>
div.el-select-dropdown.bg-dropdown-customize {
  background: rgba(0, 0, 0, 0.8) !important;
}
div.el-select-dropdown.bg-dropdown-customize .el-select-dropdown__item {
  color: white;
}
</style>
<style scoped>
:deep(.otp-field .el-input__wrapper > .el-input__prefix > .el-input__prefix-inner > div > div > svg) {
  margin-top: -3px;
  margin-left: -12px;
}
:deep(.api-input-bank .select-trigger .el-input .el-input__wrapper span span div svg) {
  margin-top: 0px;
}
:deep(.el-form-item__content .otp-field.mobile .cursor-pointer .circle) {
  left: 55px;
}
:deep(.api-input-line .el-input__prefix) {
  left: 0px;
}
:deep(.api-date-picker > .el-input__wrapper > span > span) {
  margin-top: -15px;
  margin-left: -5px;
}
.login-btn {
  opacity: 0.5;
  color: #fff;
  font-size: 24px;
  font-weight: 300;
}
:deep(.el-input__inner) {
  background-color: transparent;
  height: 24px;
  margin-left: 10px;
  color: #fff;
}
:deep(.el-input) {
  @apply bg-white relative bg-opacity-25 h-[13.5vw] pr-6 pl-3 rounded-full flex gap-3 items-center;
}
:deep(.el-form-item__error) {
  @apply px-5;
  position: unset;
  padding-top: 5px;
  font-size: 16px;
}
:deep(.el-input span) {
  font-size: 14.82px !important;
  color: rgb(250, 90, 101) !important;
  margin-right: 1px;
}
:deep(.api-input-field .el-input span) {
  color: white !important;
}
:deep(.el-form-item) {
  margin-bottom: 0;
}
:deep(.el-form-item__label) {
  color: #fff;
  font-weight: bold;
}
:deep(.el-button) {
  @apply h-[13.5vw];
}
:deep(.el-select) {
  width: 100%;
}
:deep(.el-button.el-button--danger) {
  --el-button-bg-color: green;
}
:deep(.el-input.is-disabled .el-input__inner) {
  box-shadow: none;
  background: no-repeat;
}
:deep(.el-icon) {
  @apply w-[1.5rem];
}
</style>
